/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the GetOrganizationsOrganizationIdCxTemplates200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetOrganizationsOrganizationIdCxTemplates200Response{}

// GetOrganizationsOrganizationIdCxTemplates200Response struct for GetOrganizationsOrganizationIdCxTemplates200Response
type GetOrganizationsOrganizationIdCxTemplates200Response struct {
	Resuts []CxTemplate `json:"resuts,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewGetOrganizationsOrganizationIdCxTemplates200Response instantiates a new GetOrganizationsOrganizationIdCxTemplates200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetOrganizationsOrganizationIdCxTemplates200Response() *GetOrganizationsOrganizationIdCxTemplates200Response {
	this := GetOrganizationsOrganizationIdCxTemplates200Response{}
	return &this
}

// NewGetOrganizationsOrganizationIdCxTemplates200ResponseWithDefaults instantiates a new GetOrganizationsOrganizationIdCxTemplates200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetOrganizationsOrganizationIdCxTemplates200ResponseWithDefaults() *GetOrganizationsOrganizationIdCxTemplates200Response {
	this := GetOrganizationsOrganizationIdCxTemplates200Response{}
	return &this
}

// GetResuts returns the Resuts field value if set, zero value otherwise.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) GetResuts() []CxTemplate {
	if o == nil || IsNil(o.Resuts) {
		var ret []CxTemplate
		return ret
	}
	return o.Resuts
}

// GetResutsOk returns a tuple with the Resuts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) GetResutsOk() ([]CxTemplate, bool) {
	if o == nil || IsNil(o.Resuts) {
		return nil, false
	}
	return o.Resuts, true
}

// HasResuts returns a boolean if a field has been set.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) HasResuts() bool {
	if o != nil && !IsNil(o.Resuts) {
		return true
	}

	return false
}

// SetResuts gets a reference to the given []CxTemplate and assigns it to the Resuts field.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) SetResuts(v []CxTemplate) {
	o.Resuts = v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *GetOrganizationsOrganizationIdCxTemplates200Response) SetTotal(v int32) {
	o.Total = &v
}

func (o GetOrganizationsOrganizationIdCxTemplates200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetOrganizationsOrganizationIdCxTemplates200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Resuts) {
		toSerialize["resuts"] = o.Resuts
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableGetOrganizationsOrganizationIdCxTemplates200Response struct {
	value *GetOrganizationsOrganizationIdCxTemplates200Response
	isSet bool
}

func (v NullableGetOrganizationsOrganizationIdCxTemplates200Response) Get() *GetOrganizationsOrganizationIdCxTemplates200Response {
	return v.value
}

func (v *NullableGetOrganizationsOrganizationIdCxTemplates200Response) Set(val *GetOrganizationsOrganizationIdCxTemplates200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetOrganizationsOrganizationIdCxTemplates200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetOrganizationsOrganizationIdCxTemplates200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetOrganizationsOrganizationIdCxTemplates200Response(val *GetOrganizationsOrganizationIdCxTemplates200Response) *NullableGetOrganizationsOrganizationIdCxTemplates200Response {
	return &NullableGetOrganizationsOrganizationIdCxTemplates200Response{value: val, isSet: true}
}

func (v NullableGetOrganizationsOrganizationIdCxTemplates200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetOrganizationsOrganizationIdCxTemplates200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


